package il.ac.tau.cs.dqsq.qsq2axml;

import il.ac.tau.cs.dqsq.util.dQSQUtils;
import java.io.IOException;
import org.jdom.JDOMException;

/**
 * @author pettelno
 *
 * This class represents a Peer when running in a dynamic mode, meaning when
 * the dQSQ full computation is performed, translating from dDatalog to
 * dQSQ and then to AXML.
 * In this mode the rules and relations are generated dynamically, as the
 * dQSQ rewriting evolves.
 *
 */
public class DynamicPeer extends Peer
{
	DynamicPeer(String outputDirName, String peerName) throws IOException, JDOMException
	{
    	super(outputDirName, peerName);
    	this.axmlRepository = new DynamicRepository(outputDirName);
	}
	
    void run() throws Exception
	{
    	String localURL = dQSQUtils.getPeerURL();
    	this.activityFile = new DynamicActivityFile(
    			localURL, this.peerName, outputDirName);
    	this.neighborsFile = new DynamicNeighborsFile(localURL, this.peerName);
    	super.run();
	}
}
