package il.ac.tau.cs.dqsq.qsq2axml;

/**
 * This class is used to test the QSQ2AXML generator in a standalone mode.
 * It contains a main method that runs the generator as a Java standalone 
 * application. It receives as input a Datalog program for a single peer
 * and generates the corresponding AXML documents and services. 
 * 
 */
public class QSQ2AXML
{
    public static void main(String[] args)
    {
		if (!checkArgs(args))
        {
            printUsage();
            return;
        }

        try
        {
            Peer peer = new StaticPeer(args[0], args[1]);
            peer.run();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    private static boolean checkArgs(String[] args)
    {
        if (args.length != 2)
            return false;

        return true;
    }

    private static void printUsage()
    {
        System.out.println("QSQ2AXML - Usage:\n" +
                           "----------------\n" +
                           "QSQ2AXML <peer input file> <output dir>");
    }
}
