package il.ac.tau.cs.dqsq.qsq2axml;

import org.jdom.Element;
import org.jdom.Namespace;

/**
 * @author pettelno
 *
 * Provides generic utilities for the QSQ2AXML module.
 * 
 */
public class Qsq2AxmlUtils 
{
	private static Namespace axmlNamespace = Namespace.getNamespace("axml", "http://www-rocq.inria.fr/verso/AXML");

    static Element createScElement(String desiredFrequency, String frequency, String methodName, String serviceNameSpace, 
    		String serviceURL, String mode, String subscription, String useDiff, String followedBy)
    {
    	Element scElem = new Element("sc", axmlNamespace);
    	
    	if(desiredFrequency != null)
    		scElem.setAttribute("desiredFrequency", desiredFrequency);
    	
    	if(frequency != null)
    		scElem.setAttribute("frequency", frequency);
    	
    	if(methodName != null)
    		scElem.setAttribute("methodName", methodName);
    	
    	if(serviceNameSpace != null)
    		scElem.setAttribute("serviceNameSpace", serviceNameSpace);
    	
    	if(serviceURL != null)
    		scElem.setAttribute("serviceURL", serviceURL);
    	
    	if(mode != null)
    		scElem.setAttribute("mode", mode);
    	
    	if(subscription != null)
    		scElem.setAttribute("subscription", subscription);
    	
    	if(useDiff != null)
    		scElem.setAttribute("useDiff", useDiff);
    	
    	if(followedBy != null)
    		scElem.setAttribute("followedBy", followedBy);
    	
    	return scElem;
    }
}
