package il.ac.tau.cs.dqsq.qsq2axml;

import java.io.IOException;
import java.io.File;

/**
 * @author pettelno
 *
 * A static repository of AXML documents or services. "Static" means that
 * the repositpry is built before the AXML peer starts running. The 
 * repository creates the files docRepository.xml and svcRepository.xml and
 * puts the lists of documents and services in them. When the AXML peer
 * starts running, it initializes with these documents and services.
 * 
 */
class StaticRepository implements IRepository
{
	private RepositoryRegistry docRepository;
	private RepositoryRegistry svcRepository;
	
	StaticRepository(String outputDirName)
	{
		this.docRepository = new RepositoryRegistry(outputDirName + File.separator + "docRepository.xml");
		this.svcRepository = new RepositoryRegistry(outputDirName + File.separator + "svcRepository.xml");
	}
	
	public void addDocument(String docName)
	{
		this.docRepository.addDocument(docName);
	}

	public void updateDocument(String docName)
	{
	}
	
	public void addService(String svcName)
	{
		this.svcRepository.addDocument(svcName);
	}
	
	public void flush() throws IOException
	{
		this.docRepository.flush();
		this.svcRepository.flush();
	}

	public void clear()
	{
	}
}
