package il.ac.tau.cs.dqsq.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author pettelno
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FileUtils
{
	static public void deleteFilesFromDir(File dir)
	{
		if(dir.exists())
		{
			String[] children = dir.list();
	        for(int fileIndex = 0; fileIndex < children.length; fileIndex++)
	        {
	        	// Delete only files. Don't delete directories.
	            File file = new File(dir, children[fileIndex]);
	            if(file.isFile())
	            	file.delete();
	        }
		}
	}
	
	static public void copyDir(File srcDir, File dstDir) throws IOException
	{
		String[] children = srcDir.list();
        for(int fileIndex = 0; fileIndex < children.length; fileIndex++)
        {
        	// Copy only files. Don't copy directories.
            File srcFile = new File(srcDir, children[fileIndex]);
            if(srcFile.isFile())
            	copyFile(srcFile, new File(dstDir, children[fileIndex]));
        }
	}

	static public void copyDirRecursive(File srcDir, File dstDir) throws IOException
	{
		String[] children = srcDir.list();
        for(int fileIndex = 0; fileIndex < children.length; fileIndex++)
        {
        	// Copy files and directories.
            File srcFile = new File(srcDir, children[fileIndex]);
            if(srcFile.isFile())
            	copyFile(srcFile, new File(dstDir, children[fileIndex]));
            else
            {
            	File dst = new File(dstDir, children[fileIndex]);
            	if(!dst.exists())
            		dst.mkdir();
            	copyDirRecursive(srcFile, dst);
            }
        }
	}
	
	static public void copyFile(File srcFile, File destFile) throws IOException
	{
		InputStream in = new FileInputStream(srcFile);
	    OutputStream out = new FileOutputStream(destFile);
	    
	    // Transfer bytes from in to out.
	    byte[] buf = new byte[1024];
	    int len;
	    while ((len = in.read(buf)) > 0)
           out.write(buf, 0, len);
        in.close();
        out.close();		
	}
}
