package il.ac.tau.cs.dqsq.util;

//import java.io.BufferedWriter;

/**
 * @author pettelno
 *
 * Provides logging services.
 * 
 */
public class Logger
{
	public final static int LOG_LEVEL_ERROR = 0;
	public final static int LOG_LEVEL_WARNING = 1;
	public final static int LOG_LEVEL_DEBUG = 2;
	public final static int LOG_LEVEL_FLOW = 3;
	
	private final static String[] logLevelNames = {"Error", "Warning", "Debug", "Flow"};
	
	private static String logFileName = null;
	private static int logLevel;
	private static String logLevelName = null;
//	private static BufferedWriter writer = null;

	public static void init(String peerName)
	{
//		createLogFile(peerName);
		logFileName = "dqsq.txt";
		setLogLevel();	
		
		dQSQUtils.debug("dQSQ Log - Peer " + peerName, logFileName);		
		dQSQUtils.debug("================= ", logFileName);		
	}

	public static void init(String fileName, int level)
	{
		logFileName = fileName;
		logLevel = level;
	}
	
	public static void setLogLevel()
	{
		try
		{
			logLevelName = dQSQUtils.getLogLevel();
			if(logLevelName.equalsIgnoreCase(logLevelNames[LOG_LEVEL_ERROR]))
				logLevel = LOG_LEVEL_ERROR;
			else if(logLevelName.equalsIgnoreCase(logLevelNames[LOG_LEVEL_WARNING]))
					logLevel = LOG_LEVEL_WARNING;
			else if(logLevelName.equalsIgnoreCase(logLevelNames[LOG_LEVEL_DEBUG]))
				logLevel = LOG_LEVEL_DEBUG;
			else if(logLevelName.equalsIgnoreCase(logLevelNames[LOG_LEVEL_FLOW]))
				logLevel = LOG_LEVEL_FLOW;
			else
			{
				// Default log level.
				logLevelName = "Flow";
				logLevel = LOG_LEVEL_FLOW;
			}
		}
		catch(Exception e)
		{
			// Default log level.
			logLevelName = "Flow";
			logLevel = LOG_LEVEL_FLOW;			
		}
	}
	
/*	
	public static void setPeerName(String peer)
	{
		peerName = peer;
	}
*/
	
/*
	public static void debug(String message)
	{
		dQSQUtils.debug("DEBUG: " + message, "dqsq_" + peerName + ".txt");
	}
	
	public static void error(String message)
	{
		dQSQUtils.debug("ERROR: " + message, "dqsq_" + peerName + ".txt");
	}
*/
	
	public static void sendMessage(String message, int severity)
	{
		if(severity <= logLevel)
			dQSQUtils.debug(logLevelNames[severity] + ": " + message, logFileName);
	}

/*	
	private static void createLogFile(String peerName)
	{
		try
		{
//			logFileName = "dqsq_" + peerName + ".txt";
			logFileName = "dqsq.txt";
			String logFileFullPath = dQSQUtils.getOutputDir() + File.separator + logFileName;
			writer = new BufferedWriter(new FileWriter(logFileFullPath, true));

			writer.write("<html><head><title>dQSQ Log</title></head>" + 
						 "<body><h1 align=\"center\">dQSQ Log - Peer " + peerName + "</h1>" +
						 "<p><table>" +
						 "<tr>" +
						 "<th align=\"center\">Time</th>" +
						 "<th align=\"center\">Level</th>" +
						 "<th align=\"center\">Message</th>" +
						 "</tr>" +
						 "</table></p></body></html>");
			writer.flush();
			
		}
		catch (IOException e)
		{
	    }
	}
*/	
}

