package il.ac.tau.cs.dqsq.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
//import javax.xml.parsers.DocumentBuilderFactory;
//import org.w3c.dom.Document;
//import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import fr.inria.gemo.axml.peer.AXMLPeer;
import fr.inria.gemo.axml.util.AXMLUtils;
import org.apache.axis.MessageContext;
import org.jdom.input.SAXBuilder;
import java.util.Date;
import java.text.DateFormat;

/**
 * @author pettelno
 *
 * Provides generic utilities for the entire dQSQ project.
 * Some of the methods are based on the values in the config file
 * QSQ2AXML_info.xml which is located in the user home directory.  
 *
 */
public class dQSQUtils
{
	public static String getRepositoryLocation() 
	{
		AXMLPeer axmlPeer = AXMLUtils.GetPeer(MessageContext.getCurrentContext());
		return getAxmlHome() + "repository";
	}

	private static String getAxmlHome()
	{
		AXMLPeer axmlPeer = AXMLUtils.GetPeer(MessageContext.getCurrentContext());
		return (String)axmlPeer.getProperties().get("axml.home");		
	}
	
/*	
	public static String getRepositoryLocation(String peerName) 
	{		
		String usrHomePath = System.getProperty("user.home");
		
		// Read the repository location from QSQ2AXML_info.xml.
		String infoFilePath = usrHomePath + File.separator + "QSQ2AXML_info.xml";
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();	
		Document infoDoc = null; 
		try
		{
			infoDoc = dbf.newDocumentBuilder().parse(new File(infoFilePath));
		}
		catch(Exception ex)
		{
			dQSQUtils.debug("ERROR - Failed to get repository location from QSQ2AXML_info.xml for peer " + peerName + ". System error: " + ex.getMessage(), "debug_QSQ2AxmlUtils.txt");
			return null;
		}
		
		Element docElem = infoDoc.getDocumentElement();
		NodeList peerNodes = docElem.getElementsByTagName("peer");
		int peersNum = peerNodes.getLength();

		for(int i = 0; i < peersNum; i++)
		{	
			Element curPeerElement = (Element)peerNodes.item(i);
			if(curPeerElement.getAttribute("name").equals(peerName))
			{
				NodeList elems = curPeerElement.getElementsByTagName("repositoryLocation");
				return elems.item(0).getFirstChild().getNodeValue();
			}
		}

		dQSQUtils.debug("ERROR - Failed to get repository location from QSQ2AXML_info.xml for peer " + peerName + ".", "debug_QSQ2AxmlUtils.txt");		
		return null;
	}
*/

	
	public static String getPeerURL(/*String peerName*/) 
	{
		AXMLPeer axmlPeer = AXMLUtils.GetPeer(MessageContext.getCurrentContext());
		return (String)axmlPeer.getProperties().get("axml.peer.url");
	}


/*	
	public static String getPeerURL(String peerName) 
	{
		String usrHomePath = System.getProperty("user.home");
		
		// Read the repository location from QSQ2AXML_info.xml.
		String infoFilePath = usrHomePath + File.separator + "QSQ2AXML_info.xml";
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();	
		Document infoDoc = null; 
		try
		{
			infoDoc = dbf.newDocumentBuilder().parse(new File(infoFilePath));
		}
		catch(Exception ex)
		{
			dQSQUtils.debug("ERROR - Failed to get peer URL from QSQ2AXML_info.xml for peer " + peerName + ". System error: " + ex.getMessage(), "debug_QSQ2AxmlUtils.txt");
			return null;
		}
		
		Element docElem = infoDoc.getDocumentElement();
		NodeList peerNodes = docElem.getElementsByTagName("peer");
		int peersNum = peerNodes.getLength();

		for(int i = 0; i < peersNum; i++)
		{	
			Element curPeerElement = (Element)peerNodes.item(i);
			if(curPeerElement.getAttribute("name").equals(peerName))
			{
				NodeList elems = curPeerElement.getElementsByTagName("URL");
				return elems.item(0).getFirstChild().getNodeValue();
			}
		}

		dQSQUtils.debug("ERROR - Failed to get peer URL from QSQ2AXML_info.xml for peer " + peerName + ".", "debug_QSQ2AxmlUtils.txt");		
		return null;
	}
*/
	
/*	
	public static String getRepositoryLocation() 
	{
		String usrHomePath = System.getProperty("user.home");
		
		// Read the repository location from QSQ2AXML_info.xml.
		String infoFilePath = usrHomePath + File.separator + "QSQ2AXML_info.xml";
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();	
		Document infoDoc = null; 
		try
		{
			infoDoc = dbf.newDocumentBuilder().parse(new File(infoFilePath));
		}
		catch(Exception ex)
		{
			dQSQUtils.debug("ERROR - Failed to get repository location from QSQ2AXML_info.xml. System error: " + ex.getMessage(), "debug_QSQ2AxmlUtils.txt");
			return null;
		}
		
		Element docElem = infoDoc.getDocumentElement();
		NodeList docNodes = docElem.getElementsByTagName("repositoryLocation");
		Element repositoryLocationElement = (Element)docNodes.item(0);
		Node repositoryLocationValueNode = repositoryLocationElement.getFirstChild();
		return repositoryLocationValueNode.getNodeValue();
	}
*/	
	/*
	public static String getRepositoryLocation() 
	{
		return "S:\\tomcat-4.1.31\\webapps\\axml2\\repository";
	}
*/
	
	public static void flushDocument(org.w3c.dom.Document doc, String fileName)
	{
		try
		{
			DOMSource source = new DOMSource(doc);
	        StreamResult result = new StreamResult(new FileOutputStream(fileName));
		
	        TransformerFactory transFactory = 
	                             TransformerFactory.newInstance();
	        Transformer transformer = transFactory.newTransformer();
	        transformer.transform(source, result);
		}
		catch(Exception e)
		{
			dQSQUtils.debug("ERROR - Failed to flush file - " + fileName, "debug_QSQ2AxmlUtils.txt");
		}
	}
	
	public static String service2Relation(String serviceName)
	{
		// The relation name is the service name without the prefix "ContService_".
		return serviceName.substring("ContService_".length());
	}
	
	public static String relation2Service(String relationName)
	{
		return "ContService_" + relationName;
	}
	
	public static boolean isLocalRule(String serviceName)
	{
		return serviceName.startsWith("Rule");
	}
	
	public static boolean areNodesEqual(Node firstNode, Node secondNode)
	{
		NodeList firstNodeChildren = firstNode.getChildNodes();
		NodeList secondNodeChildren = secondNode.getChildNodes();
		
		if(firstNodeChildren == null && secondNodeChildren == null)
			return true;
		if(firstNodeChildren == null || secondNodeChildren == null)
			return false;
		
		// We assume that the two nodes have the same number of children.
		int numOfChildren = firstNodeChildren.getLength();
		for(int i = 0; i < numOfChildren; i++)
		{
			if(firstNodeChildren.item(i).getFirstChild().getNodeValue().compareTo(
			   secondNodeChildren.item(i).getFirstChild().getNodeValue()) != 0)			
				return false;
		}
		
		return true;
	}
	
	public static void debug(String msg, String fileName)
	{
		String debugFileFullPath = getOutputDir() + File.separator + fileName;
		
//		synchronized(dQSQUtils.class)
//		{
			try
			{
		        BufferedWriter out = new BufferedWriter(new FileWriter(debugFileFullPath, true));
//		        out.write(new Long(System.currentTimeMillis()).toString());
		        out.write(DateFormat.getDateTimeInstance(
		        		DateFormat.SHORT, DateFormat.MEDIUM).format(new Date()) + " " + msg);
		        out.newLine();
		        out.close();
		    } 
			catch (IOException e)
			{
		    }
//		}
	}

	static String getOutputDir()
	{
		try
		{
			AXMLPeer axmlPeer = AXMLUtils.GetPeer(MessageContext.getCurrentContext());
			String axmlHome = (String)axmlPeer.getProperties().get("axml.home");
			return axmlHome + File.separatorChar + "dQSQ" + File.separatorChar + "log";
		}
		catch(Exception e)
		{
			// Default output dir is current dir.
			return ".";
		}
	}
	
/*	
	private static String getDebugDir()
	{
		String usrHomePath = System.getProperty("user.home");
		
		// Read the debug output directory from QSQ2AXML_info.xml.
		String infoFilePath = usrHomePath + File.separator + "QSQ2AXML_info.xml";
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();	
		Document infoDoc = null; 
		try
		{
			infoDoc = dbf.newDocumentBuilder().parse(new File(infoFilePath));
		}
		catch(Exception ex)
		{
			dQSQUtils.debug("ERROR - Failed to get debug dir from QSQ2AXML_info.xml. System error: " + ex.getMessage(), "debug_QSQ2AxmlUtils.txt");
		}
		
		Element docElem = infoDoc.getDocumentElement();
		NodeList docNodes = docElem.getElementsByTagName("debugDir");
		Element debugDirElement = (Element)docNodes.item(0);
		Node rdebugDirValueNode = debugDirElement.getFirstChild();
		return rdebugDirValueNode.getNodeValue();
	}
*/

/*	
	public static boolean isTerminationDetectionOn()
	{
		String usrHomePath = System.getProperty("user.home");
		
		// Read the debug output directory from QSQ2AXML_info.xml.
		String infoFilePath = usrHomePath + File.separator + "QSQ2AXML_info.xml";
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();	
		org.w3c.dom.Document infoDoc = null; 
		try
		{
			infoDoc = dbf.newDocumentBuilder().parse(new File(infoFilePath));
		}
		catch(Exception ex)
		{
			dQSQUtils.debug("ERROR - Failed to get debug dir from QSQ2AXML_info.xml. System error: " + ex.getMessage(), "debug_QSQ2AxmlUtils.txt");
		}
		
		org.w3c.dom.Element docElem = infoDoc.getDocumentElement();
		NodeList docNodes = docElem.getElementsByTagName("terminationDetection");
		org.w3c.dom.Element tdElement = (org.w3c.dom.Element)docNodes.item(0);
		Node tdValueNode = tdElement.getFirstChild();
		String tmp = tdValueNode.getNodeValue();
		if(tdValueNode.getNodeValue().equals("1"))
			return true;
		
		return false;
	}
*/
	
	public static boolean isTerminationDetectionOn() 
	{
		String configFilePath = getAxmlHome() + "dQSQ" +
								File.separatorChar + "dQSQ_config.xml";
		SAXBuilder builder = new SAXBuilder();     
		
		try
		{
			org.jdom.Document doc = builder.build(new File(configFilePath));       
			org.jdom.Element root = doc.getRootElement();
			org.jdom.Element terminationDetectionElem =
				root.getChild("terminationDetection");
			if(terminationDetectionElem.getValue().equals("off"))
				return false;
			return true;
		}
		catch(Exception e)
		{
			// By default, termination detection is on. 
			return true;
		}
	}
	
	public static boolean isParamBounded(String paramVal)
	{
		// Param is bounded if its value in the query is quoted.
		// E.g., for the query q(y) :- r("1", y), the first variable
		// of r is bounded and the second is not.
		return paramVal.startsWith("\"");
	}
	
	public static String trimParamVal(String paramVal)
	{
		// Removes the quotes. E.g., instead of "1" it returns 1.
		return(paramVal.substring(1, paramVal.length() - 1));
	}
	
	public static String getLogLevel() throws Exception
	{
		String configFilePath = getAxmlHome() + "dQSQ" +
		 						File.separatorChar + "dQSQ_config.xml";
        SAXBuilder builder = new SAXBuilder();     
       	org.jdom.Document doc = builder.build(new File(configFilePath));       
       	org.jdom.Element root = doc.getRootElement();
       	org.jdom.Element logLevelElem = root.getChild("logLevel");
       	return logLevelElem.getValue();        
	}
	
	public static String getServiceCallFrequency() throws Exception
	{
		String configFilePath = getAxmlHome() + "dQSQ" +
		 						File.separatorChar + "dQSQ_config.xml";
        SAXBuilder builder = new SAXBuilder();     
       	org.jdom.Document doc = builder.build(new File(configFilePath));       
       	org.jdom.Element root = doc.getRootElement();
       	org.jdom.Element scFrequencyElem = root.getChild("serviceCallFrequency");
       	return scFrequencyElem.getValue();        
	}	
}
