package il.ac.tau.cs.dqsqenv;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

/**
 * @author pettelno
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
abstract public class DQSQEnv
{
	protected final static String CONFIG_FILE_NAME = "config.xml";

	protected List peers = new ArrayList();
	int numOfPeers;
	
	public static void main(String[] args) 
	{
		if (!checkArgs(args))
        {
            printUsage();
            return;
        }

		if(args[0].equals("run"))
			new RundQSQ();
		else if(args[0].equals("install"))
				new InstalldQSQ();
		else
			printUsage();
	}

    private static boolean checkArgs(String[] args)
    {
        if (args.length != 1)
            return false;

        return true;
    }

    private static void printUsage()
    {
        System.out.println("DQSQEnv - Usage:\n" +
                           "---------------\n" +
                           "DQSQEnv run/install\n\n" +
						   "run - Runs the dQSQ system.\n" +
						   "install - Installs the dQSQ system on top of AXML.");
    }
    
	protected void readConfig() throws Exception
	{
		SAXBuilder builder = new SAXBuilder();     
		Document doc = builder.build(new File(CONFIG_FILE_NAME));
		
		Element root = doc.getRootElement();
		List peerElems = root.getChildren();
		this.numOfPeers = peerElems.size();
			
		for(int peerIndex = 0; peerIndex < this.numOfPeers; peerIndex++)
			this.peers.add(peerIndex, new Peer((Element)peerElems.get(peerIndex)));
	}    
}
