package il.ac.tau.cs.dqsqenv;

import java.io.File;
import java.io.FileOutputStream;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.XMLOutputter;

/**
 * @author pettelno
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
class InstalldQSQ extends DQSQEnv
{
	public final static String LOG_FILE_NAME = "log" + File.separatorChar + "installdQSQ.txt";
	
	protected InstalldQSQ()
	{
		try
		{
			readConfig();
			install();
			createdQSQHomePageHtml();
			Utils.debug("dQSQ installed successfully.", LOG_FILE_NAME);
		}
		catch(Exception e)
		{
			Utils.debug("Failed to install dQSQ. " + e.getMessage() , LOG_FILE_NAME);
		}		
	}
	
	private void install() throws Exception
	{
		for(int peerIndex = 0; peerIndex < this.numOfPeers; peerIndex++)
			((Peer)this.peers.get(peerIndex)).install();
	}
	
	private void createdQSQHomePageHtml() throws Exception
	{
        Element root = new Element("html");
        root.addContent(new Element("head"));

        if(countActivePeers() <= 1)
        {
            Element frameSetElem = root.addContent(new Element("frameset"));
        	Element frameElem = new Element("frame");
        	frameElem.setAttribute("name", "f1");
        	frameElem.setAttribute("src", "http://localhost:8080/axml/jsp/dQSQ/dQSQ.jsp");
        	frameSetElem.addContent(frameElem);
        }
        else
        {
        	Element bodyElement = new Element("body");
        	
        	Element hElement = new Element("h2").setAttribute("align", "center");
        	hElement.setText("Choose dQSQ peer:");
        	bodyElement.addContent(hElement);
        	
        	Element pElement = new Element("p").setAttribute("align", "center");
        	hElement.setText("Choose peer:");
        	
        	for(int peerIndex = 0; peerIndex < this.numOfPeers; peerIndex++)
        	{
        		Element linkElem = ((Peer)this.peers.get(peerIndex)).createHtmlLinkToHomePage();
        		if(linkElem != null)
        		{
        			pElement.addContent(linkElem);
        			pElement.addContent(new Element("br"));
        			pElement.addContent(new Element("br"));
        		}
        	}
        	
        	bodyElement.addContent(pElement);
            root.addContent(bodyElement);
        }
        
        Document outDoc = new Document(root);
        
        // Save the file.
        FileOutputStream out = new FileOutputStream("dQSQHomePage.html");
        XMLOutputter serializer = new XMLOutputter();
        serializer.output(outDoc, out);
        out.flush();
        out.close();
		
	}
	
	private int countActivePeers()
	{
		int numOfActivePeers = 0;
    	for(int peerIndex = 0; peerIndex < this.numOfPeers; peerIndex++)
    	{
    		if(((Peer)this.peers.get(peerIndex)).isActive())
    			numOfActivePeers++;
    	}
    	
    	return numOfActivePeers;
	}
}
