package il.ac.tau.cs.dqsqenv;

import java.io.File;
import java.io.IOException;

/**
 * @author pettelno
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
class RundQSQ extends DQSQEnv
{
	private static String LOG_FILE_NAME = "log" + File.separatorChar + "rundQSQ.txt";
	
	protected RundQSQ()
	{
		try
		{
			Utils.debug("Running dQSQ.", LOG_FILE_NAME);
			readConfig();
			initRepository();
			initLogDir();
			runAXML();
		}
		catch(Exception e)
		{
			Utils.debug("Failed to run dQSQ. " + e.getMessage() , LOG_FILE_NAME);
		}
	}
		
	private void initRepository() throws IOException
	{
		for(int peerIndex = 0; peerIndex < this.numOfPeers; peerIndex++)
			((Peer)this.peers.get(peerIndex)).initRepository();
	}

	private void initLogDir()
	{
		for(int peerIndex = 0; peerIndex < this.numOfPeers; peerIndex++)
			((Peer)this.peers.get(peerIndex)).initLogDir();
	}

	private void runAXML()
	{
		String tomcatBinDir = getTomcatBinDir();
		try
		{
			Runtime.getRuntime().exec(tomcatBinDir + File.separatorChar + "startup.bat",
									  null,
									  new File(tomcatBinDir));
			
			// Without the sleep the process is terminated before AXML
			// starts running.
			Thread.sleep(1000);
		}
		catch(Exception e)
		{
		}
	}
	
	private String getTomcatBinDir()
	{
		// Get the first peer's AXML home dir.
		String axmlHomeDir = ((Peer)this.peers.get(0)).getAxmlHomeDir();
		String[] splittedAxmlHomeDir = axmlHomeDir.split("webapps");
		return splittedAxmlHomeDir[0] + File.separatorChar + "bin";
	}
}
